$TITLE(IIC_Read_Rep_Write command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master routine sends slave addres_1, reads data bytes to buffer_1,
;sends a repeat START, slave address_2 and data bytes to buffer_2
;
;PL/M declaration:
;IIC_Read_Rep_Write:
;Procedure(Sl_Address_1,Count_1,Source_ptr_1,Sl_Address_2,Count_2,Source_ptr_2)
;                                                            Bit|Byte External;
;  Declare(Sl_Address_1,Count_1,Source_ptr_1,Sl_Address_2,Count_2,Source_ptr_2)
;                                                           Byte;
;End;
;
;Input parameters: Sl_Address_1:   Address of slave transmitter #1
;                  Count_1     :   Number of bytes to receive from slave 
;                                  transmitter #1 to buffer_1        
;                  Source_ptr_1:   Pointer to buffer_1 (IDATA 0..255)
;                  Sl_Address_2:   Address of slave receiver #2
;                  Count_2     :   Number of bytes to send to slave receiver #2
;                                  from buffer_2
;                  Source_ptr_2:   Pointer to buffer_2 (IDATA 0..255)
;
;Used register: Defined by _IIC_WRITE
;
;******************************************************************************

                PUBLIC _IIC_READ_REP_WRITE

                EXTRN CODE(RCV_NO_STOP,EXCHANGE,GEN_START_TRX,TRX_LOOP,I2C_STOP)
                EXTRN CODE(CONTEXT_SW)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

;******************************************************************************
;
_IIC_READ_REP_WRITE:
        ACALL CONTEXT_SW        ;Select RB1
        CLR EN_STOP
        ACALL RCV_NO_STOP       ;Receive bytes to buffer_1. No STOP
        JB IIC_ERROR,EXIT
        ACALL EXCHANGE          ;Copy sequence_2 param. to sequence_1 param.
        ACALL GEN_START_TRX     ;Generate repeat START and trx slave address_2
        JB IIC_ERROR,ST_EXIT
        SETB EN_STOP
        ACALL TRX_LOOP          ;Trx databytes from buffer_2 and STOP
EXIT:   RET

ST_EXIT:ACALL I2C_STOP          ;Error escape
        RET
;
        END
