$TITLE(IIC_Read_Sub command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master receive routine with sub-address
;
;PL/M declaration:
;IIC_Read_Sub:  Procedure(Slave_adr,Count,Source_ptr,Sub_adr) Bit|Byte External;
;               Declare(Slave_adr,Count,Source_ptr,Sub_adr) Byte;
;               End;
;
;Input parameters: Slave_adr: Address of slave transmitter
;                  Count:     Number of bytes to be received
;                             (excl. slave address and sub address)
;                  Source_ptr:Pointer to receive buffer (IDATA 0..255)
;                  Sub_adr:   Sub_address in slave device 
;Output parameters:Contents of STATUS byte
;                  Contents of IIC_Error Bit
;
;Used register: defined by _IIC_WRITE and _IIC_READ
;               R5: Temporary store for Nr_Bytes
;
;In _IIC_READ the error checking is done
;
;******************************************************************************

                PUBLIC _IIC_READ_SUB

                EXTRN CODE(SUB_NO_STOP,GEN_START_RCV,RCV_LOOP,I2C_STOP)
                EXTRN CODE(CONTEXT_SW)
                EXTRN DATA(COUNT_1)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER 

                TEMP_COUNT      SET R5
  
;******************************************************************************

_IIC_READ_SUB:
        ACALL CONTEXT_SW        ;Select RB1
        MOV TEMP_COUNT,COUNT_1  ;Store receive_count parameter
        MOV COUNT_1,#00         ;Trx no data bytes
        CLR EN_STOP             ;Disable STOP generation
        ACALL SUB_NO_STOP       ;Trx START, sl_address and sub_address
        SETB EN_STOP            ;Close next sequence with STOP
        JB IIC_ERROR,EXIT       ;Check on errors. STOP done in SUB_NO_STOP
        MOV COUNT_1,TEMP_COUNT  ;Restore receive_count parameter
        ACALL GEN_START_RCV     ;Generate a repeated START condition
        ACALL RCV_LOOP          ;Receive data bytes. Error checking and 
                                ;STOP condition done in _IIC_READ.
EXIT:   RET
;
        END
