$TITLE(IIC_Write_Comm_Write command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master routine sends slave addres, command bytes from buffer_1,
;and data bytes from buffer_2
;
;PL/M declaration:
;IIC_Write_Comm_Write:
;Procedure(Sl_Address_1,Count_1,Source_ptr_1,Count_2,Source_ptr_2)
;                                                            Bit|Byte External;
;  Declare(Sl_Address_1,Count_1,Source_ptr_1,Count_2,Source_ptr_2)
;                                                           Byte;
;End;
;
;Input parameters: Sl_Address_1:   Address of slave receiver #1
;                  Count_1     :   Number of bytes to send to slave receiver #1
;                                  from buffer_1
;                  Source_ptr_1:   Pointer to buffer_1 (IDATA 0..255)
;                  Count_2     :   Number of bytes to send to slave receiver #2
;                                  from buffer_2
;                  Source_ptr_2:   Pointer to buffer_2 (IDATA 0..255)
;
;Used register: Defined by _IIC_WRITE
;
;******************************************************************************

                PUBLIC _IIC_WRITE_COM_WRITE

                EXTRN CODE(IIC_NO_STOP,EXCHANGE,TRX_LOOP,CONTEXT_SW)
                EXTRN DATA(SOURCE_PTR_2,COUNT_2,SUB_ADR)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

;******************************************************************************
;
_IIC_WRITE_COM_WRITE:
        ACALL CONTEXT_SW        ;Select RB1
        MOV SOURCE_PTR_2,COUNT_2;Rearrange input parameters
        MOV COUNT_2,SUB_ADR
        CLR EN_STOP             ;No STOP when writing command bytes 
                                ;from buffer_0
        ACALL IIC_NO_STOP       ;Trx to slave receiver from buffer_1
        JB IIC_ERROR,EXIT        
        ACALL EXCHANGE          ;Copy sequence_2 param. to sequence_1 param.
        SETB EN_STOP
        ACALL TRX_LOOP          ;Trx data bytes from buffer_2  and STOP
EXIT:   RET
;
        END
