$TITLE(IIC_Write command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master transmit routine.
;
;PL/M declaration: 
;       IIC_Write: Procedure(Sl_Address,Nr_bytes,Source_ptr) Byte|Bit Ext;
;                  Declare(Sl_Address,Nr_bytes,Source_ptr,Time_out) Byte;      
;                  End;
;
;Input parameters: Sl_Address: Address of slave receiver 
;                  Nr_Bytes:   Number of bytes to send (excl. slave address)
;                  Source_ptr: Pointer to send buffer (IDATA 0..255)
;Output parameter: Contents of STATUS is passed to PL/M
;
;Used registers:   R0: Pointer to transmit buffer
;                  R2: Bit counter
;                  R3: Time_out register
;                  R4: Byte counter
;Parts of this routine are used by other modules
;
;******************************************************************************

                PUBLIC _IIC_WRITE
                PUBLIC IIC_NO_STOP,TRX_LOOP
                EXTRN  CODE(START_TRX,I2C_STOP,TRX_BY,CONTEXT_SW)
                EXTRN  DATA(SOURCE_PTR_1,COUNT_1)
                EXTRN  BIT(IIC_Error,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

                BUF_POINT       SET R0
                BIT_CNT         SET R2
                SOFT_TIM        SET R3
                BYTE_CNT        SET R4

;******************************************************************************
;Transmit bytes from buffer to I2C bus
;******************************************************************************
_IIC_WRITE:
        SETB EN_STOP            ;A STOP condition must be transmitted
        ACALL CONTEXT_SW        ;Select RB1
IIC_NO_STOP:
        ACALL START_TRX         ;Initialise master and generate START
        JB IIC_ERROR,EXIT       ;Test if error occurred
TRX_LOOP:
        MOV BYTE_CNT,COUNT_1    ;Init byte counter
        MOV A,BYTE_CNT          ;Check if only slave address must be sent
        JZ EXIT
        MOV BUF_POINT,SOURCE_PTR_1 ;Init buffer pointer
NXT_TR: MOV A,@BUF_POINT        ;Get byte to transmit
        ACALL TRX_BY            ;Send byte from transmit buffer 
                                ;and update BUF_POINT
        JB IIC_ERROR,EXIT       ;Test if error occurred
        DJNZ BYTE_CNT,NXT_TR    ;Check if more bytes have to be send
EXIT:   ACALL I2C_STOP          ;Finish I2C transmission
        RET
;
        END
