$TITLE(IIC_Write_Rep_Read command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master routine sends slave addres_1, data bytes from buffer_1,
;a repeat START, slave address_2 and receives data bytes to buffer_2
;
;PL/M declaration:
;IIC_Write_Rep_Read:
;Procedure(Sl_Address_1,Count_1,Source_ptr_1,Sl_Address_2,Count_2,Source_ptr_2)
;                                                            Bit|Byte External;
;  Declare(Sl_Address_1,Count_1,Source_ptr_1,Sl_Address_2,Count_2,Source_ptr_2)
;                                                           Byte;
;End;
;
;Input parameters: Sl_Address_1:   Address of slave receiver #1
;                  Count_1     :   Number of bytes to send to slave receiver #1
;                                  from buffer_1
;                  Source_ptr_1:   Pointer to buffer_1 (IDATA 0..255)
;                  Sl_Address_2:   Address of slave receiver #2
;                  Count_2     :   Number of bytes to receive from slave
;                                  transmitter #2 to buffer_2
;                  Source_ptr_2:   Pointer to buffer_2 (IDATA 0..255)
;
;Used register: Defined by _IIC_WRITE
;
;******************************************************************************

                PUBLIC _IIC_WRITE_REP_READ

                EXTRN CODE(IIC_NO_STOP,EXCHANGE,GEN_START_RCV,RCV_LOOP,I2C_STOP)
                EXTRN CODE(CONTEXT_SW)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

;******************************************************************************
;
_IIC_WRITE_REP_READ:
        CLR EN_STOP             ;No STOP when writing bytes from buffer_0
        ACALL CONTEXT_SW        ;Select RB1
        ACALL IIC_NO_STOP       ;Trx to slave receiver_1 from buffer_1
        JB IIC_ERROR,EXIT        
        ACALL EXCHANGE          ;Copy sequence_2 param. to sequence_1 param.
        ACALL GEN_START_RCV     ;Generate repeat START and trx slave address_2
        JB IIC_ERROR,ST_EXIT
        SETB EN_STOP
        ACALL RCV_LOOP          ;Rcv data bytes and store in buffer_2. Send STOP 
EXIT:   RET

ST_EXIT:ACALL I2C_STOP          ;Error escape
        RET
;
        END
