$TITLE(IIC_Write_Sub_Read)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master routine sends slave adress, sub-address,
;data from buffer_1, sends repeated START and slave address
;receives data bytes and stores them in buffer_2.
;
;PL/M declaration: 
;IIC_Write_Sub_Read: 
;Procedure(Sl_Address,Count_1,Source_ptr_1,Sub_Address,Count_2,Dest_ptr_2)
;                                                          Bit|Byte External;
;Declare(Sl_Address,Count_1,Source_ptr_1,Sub_Address,Count_2,Source_ptr_2) Byte;
;End;
;
;Input parameters: Sl_Address:    Address of slave receiver
;                  Count_1:       Number of bytes to transmit from buffer_1
;                  Source_ptr_1:  Pointer to send buffer_1 (IDATA 0..255)
;                  Sub_Address:   Sub address within slave device 
;                  Count_2:       Number of bytes to transmit from buffer_2
;                  Dest_ptr_2:    Pointer to rcv buffer_2 (IDATA 0..255)
;Output parameter: STATUS byte and IIC_Error bit.
;
;Used registers:   Defined by _IIC_WRITE and _IIC_READ
;
;******************************************************************************

                PUBLIC _IIC_WRITE_SUB_READ
                
                EXTRN CODE(SUB_NO_STOP,RCV_LOOP,GEN_START_RCV,I2C_STOP)
                EXTRN CODE(CONTEXT_SW,SUB_EXCH)
                EXTRN DATA(COUNT_1,SOURCE_PTR_1) 
                EXTRN DATA(COUNT_2,SOURCE_PTR_2)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK 
                RSEG I2C_DRIVER

;******************************************************************************
;
_IIC_WRITE_SUB_READ:
        CLR EN_STOP             ;No STOP after writing bytes from buffer_0
        ACALL CONTEXT_SW        ;Selecl RB1
        ACALL SUB_NO_STOP       ;Transmit slave_addr, sub_addr and bytes 
                                ;from buffer_1
        SETB EN_STOP            ;2nd sequence must end with STOP
        JB IIC_ERROR,EXIT
        SETB EN_STOP            ;2nd sequence must end with STOP
        ACALL SUB_EXCH          ;Prepare count and source_ptr for data transfer
        ACALL GEN_START_RCV     ;Generate repeated START
        JB IIC_ERROR,ST_EXIT    ;Generate STOP if error
        ACALL RCV_LOOP          ;Receive bytes
EXIT:   RET                                            
ST_EXIT:ACALL I2C_STOP
        RET
;
        END
