$TITLE(IIC_Write_Sub_SWinc)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master transmit routine with software auto increment of
;sub address.
;
;PL/M declaration: 
;IIC_Write_Sub_SWinc: Procedure(Sl_Address,Count_1,Source_ptr,Sub_Address)
;                                                       Bit|Byte External;
;                     Declare(Sl_Address,Count_1,Source_ptr,Sub_Address) Byte;
;                     End;
;
;Input parameters: Sl_Address: Address of slave receiver
;                  Count_1:    Number of bytes to transmit
;                              (excl. slave address and sub address)
;                  Source_ptr: Pointer to send buffer (IDATA 0..255)
;                  Sub_Address:Sub address with slave device
;Output parameter: STATUS byte and IIC_Error bit.
;
;Used registers: see _IIC_WRITE
;                R5: Sub address of sequence to transmit
;
;******************************************************************************

                PUBLIC _IIC_WRITE_SUB_SWINC
                
                EXTRN CODE(_IIC_WRITE_SUB,CONTEXT_SW)
                EXTRN DATA(COUNT_1,COUNT_2,SOURCE_PTR_1,SUB_ADR)
                EXTRN BIT(IIC_ERROR)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

                SEQ_NR          SET R5

;******************************************************************************
;
_IIC_WRITE_SUB_SWINC:
        MOV COUNT_2,COUNT_1     ;Get number of sequences
        MOV COUNT_1,#01         ;Sequence contains 1 data byte

NXT_TRX:ACALL _IIC_WRITE_SUB    ;Transmit sequence with STOP
        JB IIC_ERROR,EXIT       ;Error checking and STOP done in _IIC_WRITE
NXT_SEQ:INC SUB_ADR             ;Incr sub address for next sequence
        INC SOURCE_PTR_1        ;Incr buffer pointer for next bit
        DJNZ COUNT_2,NXT_TRX    ;Transmit next sequence
EXIT:   
        RET
;
        END
