$TITLE(IIC_Write_Sub command)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master transmit routine with sub-address
;
;PL/M declaration:
;IIC_Write_Sub: Procedure(Slave_adr,Count,Source_ptr,Sub_adr) Bit|Byte External;
;               Declare(Slave_adr,Count,Source_ptr,Sub_adr) Byte;
;               End;
;
;Input parameters: Slave_adr: Address of slave receiver
;                  Count:     Number of bytes to send (excl. slave address and
;                                                            sub address)
;                  Source_ptr:Pointer to send buffer (IDATA 0..255)
;                  Sub_adr:   Sub_address in slave device 
;Output parameters:Contents of STATUS byte
;                  Contents of IIC_Error Bit
;
;Used register: defined by _IIC_WRITE
;
;In _IIC_WRITE the error checking is done
;
;******************************************************************************

                PUBLIC _IIC_WRITE_SUB
                PUBLIC SUB_NO_STOP

                EXTRN CODE(START_TRX,TRX_BY,TRX_LOOP,I2C_STOP)
                EXTRN CODE(CONTEXT_SW)
                EXTRN DATA(COUNT_1,SOURCE_PTR_1,SUB_ADR)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER 

;******************************************************************************

_IIC_WRITE_SUB:
        SETB EN_STOP            ;STOP condition after end of transmission
        ACALL CONTEXT_SW        ;Select SW1
SUB_NO_STOP:
        ACALL START_TRX         ;Initialise master and generate START
        JB IIC_ERROR,EXIT
        MOV A,SUB_ADR           ;Get sub address
        ACALL TRX_BY            ;Transmit sub address
        JB IIC_ERROR,EXIT
        ACALL TRX_LOOP          ;Transmit data bytes, error checking and
                                ;STOP condition done in _IIC_WRITE.
        RET
EXIT:   ACALL I2C_STOP          ;Stop I2C transmission
        RET
;
        END
