$TITLE(IIC_Write_Sub_Write)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C master transmit routine sends slave adress, sub-address,
;data from buffer_1 and data from buffer_2.
;
;PL/M declaration: 
;IIC_Write_Sub_Write: 
;Procedure(Sl_Address,Count_1,Source_ptr_1,Sub_Address,Count_2,Source_ptr_2)
;                                                          Bit|Byte External;
;Declare(Sl_Address,Count_1,Source_ptr_1,Sub_Address,Count_2,Source_ptr_2) Byte;
;End;
;
;Input parameters: Sl_Address:    Address of slave receiver
;                  Count_1:       Number of bytes to transmit from buffer_1
;                  Source_ptr_1:  Pointer to send buffer_1 (IDATA 0..255)
;                  Sub_Address:   Sub address within slave device 
;                  Count_2:       Number of bytes to transmit from buffer_2
;                  Source_ptr_2:  Pointer to send buffer_2 (IDATA 0..255)
;Output parameter: STATUS byte and IIC_Error bit.
;
;Used registers:   Defined by _IIC_WRITE
;
;******************************************************************************

                PUBLIC _IIC_WRITE_SUB_WRITE
                
                EXTRN CODE(SUB_NO_STOP,TRX_LOOP,I2C_STOP,CONTEXT_SW,SUB_EXCH)
                EXTRN DATA(SLAVE_ADR,COUNT_1,SOURCE_PTR_1,SUB_ADR) 
                EXTRN DATA(COUNT_2,SOURCE_PTR_2)
                EXTRN BIT(IIC_ERROR,EN_STOP)

                I2C_DRIVER SEGMENT CODE INBLOCK 
                RSEG I2C_DRIVER

;******************************************************************************
;
_IIC_WRITE_SUB_WRITE:
        CLR  EN_STOP            ;No STOP after writing bytes from buffer_0
        ACALL CONTEXT_SW        ;Select RB1
        ACALL SUB_NO_STOP       ;Transmit slave_addr, sub_addr and bytes 
                                ;from buffer_1
        JB IIC_ERROR,EXIT

        SETB EN_STOP            ;Next sequence must end with STOP
        ACALL SUB_EXCH          ;Prepare count and source_ptr for 2nd trx
        ACALL TRX_LOOP          ;Transmit bytes and STOP
EXIT:   RET
;
        END
