$TITLE (Initialise and enable I2C interface)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C interface is enabled. Bus will now be checked and can be monitored
;with BB-bit.
;Own slave address is stored in R7.
;Slave_Sub_Address stored in RAM
;I2C interrupt will be enabled.
;
;Declaration: Init_IIC: Procedure(Own_Slave_Ad,Slave_sub_Address) External;
;                       Declare(Own_Slave_Ad) Byte;
;                       End;
;            
;******************************************************************************

        PUBLIC _INIT_IIC

        EXTRN DATA(SLAVE_ADR,COUNT_1,SLAVE_SUB_ADDRESS,STATUS)
        EXTRN CODE(CONTEXT_SW)

        I2C_DRIVER SEGMENT CODE INBLOCK
        RSEG I2C_DRIVER
 
        OWN_SLAVE       SET R7      
        CONTEXT         SET R6

;*****************************************************************************

_INIT_IIC:
        ACALL CONTEXT_SW        ;Select RB1
        MOV OWN_SLAVE,SLAVE_ADR ;Store slave address
        MOV SLAVE_SUB_ADDRESS,COUNT_1 ;Store addres pointer for slave mode
        ORL S1SCS,#11000000B    ;Set SDA/SCL lines
        SETB ENS                ;Enable I2C interface
        SETB ES1                ;Enable I2C interrupt
        MOV STATUS,#00          ;Clear status
        MOV PSW,CONTEXT         ;Restore context
        RET
;
        END
