$TITLE(Receive byte routine)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;Routine to receive 1 byte from the I2C bus
;Routine is used by other modules
;
;Used registers as in _IIC_READ
;
;******************************************************************************

                PUBLIC RCV_BY

                EXTRN  CODE(ERROR_CHK)
                EXTRN  BIT(IIC_Error,EN_ARB)


                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

                BUF_POINT       SET R0
                TEMP            SET R1
                BIT_CNT         SET R2
                SOFT_TIM        SET R3
                BYTE_CNT        SET R4

;******************************************************************************
;Receive byte from I2C bus
;Byte to be received stored in buffer
;******************************************************************************
RCV_BY:
        MOV BIT_CNT,#08         ;Init bit counter
        CLR EN_ARB              ;Disable ARB_LOST check
NXT_RCV:
        MOV A,S1BIT             ;Receive bit in ACC.7
        RLC A                   ;Store previous received bit in CY
        MOV A,@BUF_POINT        ;Get byte to receive
        RLC A                   ;Store CY in byte to receive
        MOV @BUF_POINT,A
        MOV SOFT_TIM,#01
        DJNZ SOFT_TIM,$ 
        NOP
        MOV SOFT_TIM,#0FFH      ;Set time-out
        DJNZ BIT_CNT,TEST_RCV

LAST_RCV_CHK:                   ;Test for last received bit
        JB RBF,ACK_GEN
        ACALL ERROR_CHK         ;Check for errors
        JNB IIC_Error,LAST_RCV_CHK      ;No error
        SJMP OUT                ;Error

TEST_RCV:
        JB RBF,NXT_RCV
        ACALL ERROR_CHK         ;Check for errors
        JNB IIC_ERROR,TEST_RCV
        RET                     ;Exit on error

ACK_GEN:                        ;Generate ACK clock puls
        CJNE BYTE_CNT,#01,SEND_ACK ;Test if last byte is received
        SETB EN_ARB             ;Enable ARB_LOST check
        MOV TEMP,#80h           ;Trx value for NO_ACK
        SJMP SEND
SEND_ACK: MOV TEMP,#00          ;Trx value for ACK
SEND:   MOV S1BIT,TEMP          ;Trx ACK/NO_ACK
        MOV C,SDI               ;Get last received bit without initiating CLK
        MOV A,@BUF_POINT        
        RLC A
        MOV @BUF_POINT,A
        SETB C                  ;Trx-bit for ARB_CHECK if NO_ACK is sent
        MOV SOFT_TIM,#02        ;Delay for tuning
        DJNZ SOFT_TIM,$
        MOV SOFT_TIM,#0FFH     ;Set time-out
        INC BUF_POINT           ;Update pointer for next byte to receive
TEST_TRX:
        JB WBF,TRX_DONE
        ACALL ERROR_CHK         ;Do error check
        JNB IIC_ERROR,TEST_TRX

TRX_DONE:SETB SDO                ;Release SDA line
OUT:    RET
      
        END
