$TITLE(Transmit byte routine)
$DEBUG
$NOLIST
$INCLUDE(C:\TOOLS\TASKING\ASM51\INCLUDE\8051\REG528.INC)
$LIST
;
;I2C trx-byte and trx-bit routines.
;These routines are used by other modules. 
;
;Registers used as in _IIC_WRITE
;
;******************************************************************************

                PUBLIC TRX_BY
                EXTRN  CODE(I2C_STOP,ERROR_CHK)
                EXTRN  BIT(IIC_Error,NO_ACK,EN_ARB)

                I2C_DRIVER SEGMENT CODE INBLOCK
                RSEG I2C_DRIVER

                BUF_POINT       SET R0
                BIT_CNT         SET R2
                SOFT_TIM        SET R3
                BYTE_CNT        SET R4

;******************************************************************************
;Transmit byte to I2C bus
;Byte to be transmitted in ACC
;******************************************************************************
TRX_BY:
        MOV BIT_CNT,#08         ;Set bit counter
NXT_TR:                         ;Time between this instruction and WBF-test
                                ;optimized for max. speed
        MOV S1BIT,A             ;Transmit ACC.7
        RLC A                   ;Get bit for next transmission
        SETB EN_ARB             ;Enable arbitration checking
        MOV SOFT_TIM,#03        ;Delay to let first WBF check coincide
        DJNZ SOFT_TIM,$         ;with fastest speed
        NOP
        MOV SOFT_TIM,#0FFH      ;Set time-out
        DJNZ BIT_CNT,TEST_TRX

LAST_TR_CHK:                    
        JB WBF,ACK_CHK          ;Last bit is sent, check ACK
        ACALL ERROR_CHK         ;Check for errors
        JNB IIC_ERROR,LAST_TR_CHK   
        RET                     ;Error condition detected

TEST_TRX:
        JB WBF,NXT_TR          
        ACALL ERROR_CHK         ;Check for errors
        JNB IIC_ERROR,TEST_TRX
        RET                     ;Error condition detected

ACK_CHK:                        ;Check ACK
        SETB SDO                ;Make SDA=1 for ACK check
        MOV A,S1BIT             ;Read bit
        CLR EN_ARB              ;Disable ARB_LOST check
        MOV SOFT_TIM,#3         ;Delay for max speed
TUNE_2: DJNZ SOFT_TIM,TUNE_2    
        MOV SOFT_TIM,#0FFH      ;Set time out
        INC BUF_POINT           ;Update pointer for next byte
TEST_RCV:
        JB RBF,RCV_DONE
        ACALL ERROR_CHK
        JNB IIC_ERROR,TEST_RCV
        RET                     ;Reception of ACK/NOACK not successfull
RCV_DONE:                       
        JNB SDI,LEAVE           ;If received bit is '0', then ACK received
        SETB NO_ACK             ;No ACK, Set error flags
        SETB IIC_ERROR          
LEAVE:  RET

;
;
        END
