$TITLE(Variables)
$DEBUG


;****************************************************************************
;*                                                                          *
;*               I2C DRIVER FOR 8xC528 MICRO CONTROLLER                     *
;*                                                                          *
;*               VERSION:    1.0                                            *
;*                                                                          *
;*               DATE:       23-01-1990                                     *
;*                                                                          *
;*               WRITTEN BY: T. v. Daele                                    *
;*                           Philips Semiconductors                         *
;*                           Product Concept and Application Laboratory     *
;*                           Eindhoven (NL)                                 *
;*                                                                          *
;****************************************************************************
 

;Definition of parameters is done

        PUBLIC _INIT_IIC_BYTE,_IIC_WRITE_BYTE,_IIC_READ_BYTE
        PUBLIC _IIC_TEST_DEVICE_BYTE,_IIC_WRITE_SUB_BYTE
        PUBLIC _IIC_WRITE_SUB_SWINC_BYTE,_IIC_WRITE_MEMORY_BYTE
        PUBLIC _IIC_WRITE_SUB_WRITE_BYTE,_IIC_READ_STATUS_BYTE
        PUBLIC _IIC_READ_SUB_BYTE,_IIC_WRITE_SUB_READ_BYTE
        PUBLIC _IIC_WRITE_COM_WRITE_BYTE,_IIC_WRITE_REP_WRITE_BYTE
        PUBLIC _IIC_WRITE_REP_READ_BYTE,_IIC_READ_REP_WRITE_BYTE
        PUBLIC _IIC_READ_REP_READ_BYTE
        PUBLIC SLAVE_ADR,COUNT_1,SOURCE_PTR_1,SUB_ADR,COUNT_2,SOURCE_PTR_2
        PUBLIC SLAVE_SUB_ADDRESS,STATUS
        PUBLIC IIC_ERROR,NO_ACK,ARB_LOST,TIME_ERR,BUS_ERROR,NO_ACCESS
        PUBLIC EN_STOP,EN_ARB 

        I2C_VAR_1 SEGMENT DATA
        RSEG I2C_VAR_1

_INIT_IIC_BYTE:
_IIC_WRITE_BYTE:
_IIC_READ_BYTE:
_IIC_TEST_DEVICE_BYTE:
_IIC_WRITE_SUB_BYTE:
_IIC_WRITE_SUB_SWINC_BYTE:
_IIC_WRITE_MEMORY_BYTE:
_IIC_WRITE_SUB_WRITE_BYTE:
_IIC_READ_STATUS_BYTE:
_IIC_READ_SUB_BYTE:
_IIC_WRITE_SUB_READ_BYTE:
_IIC_WRITE_REP_WRITE_BYTE:
_IIC_WRITE_REP_READ_BYTE:
_IIC_READ_REP_WRITE_BYTE:
_IIC_READ_REP_READ_BYTE:
_IIC_WRITE_COM_WRITE_BYTE:
        SLAVE_ADR:      DS 1
        COUNT_1:        DS 1
        SOURCE_PTR_1:   DS 1    
        SUB_ADR:        DS 1
        COUNT_2:        DS 1
        SOURCE_PTR_2:   DS 1
;                 
;
        SLAVE_SUB_ADDRESS: DS 1
;
        I2C_VAR_2 SEGMENT DATA BITADDRESSABLE
        RSEG I2C_VAR_2
        STATUS:    DS 1
        IIC_Error  BIT STATUS.0       ;An error has occurred (RD)
        NO_ACK     BIT STATUS.1       ;No ACK received (RD)
        ARB_LOST   BIT STATUS.2       ;Arbitration lost (RD)
        TIME_ERR   BIT STATUS.3       ;Time out error (RD)
        BUS_ERROR  BIT STATUS.4       ;Bus error (RD)
        NO_ACCESS  BIT STATUS.5       ;No access to I2C bus (RD)
        EN_STOP    BIT STATUS.6       ;Enable STOP generation (WR)
        EN_ARB     BIT STATUS.7       ;Enable arbritration check (WR)

        END
